<script lang="ts">
    import {
        subplot_template_empty,
        subplot_template_xray_flux,
        subplot_template_hp30_index,
        subplot_template_imf,
        subplot_template_sunspots,
        subplot_template_f10_7,
        subplot_template_swarm_ne,
        subplot_template_ae_magnetometers,
        subplot_template_gold,
    } from "./templates/subplot_template.js";
    import {
        set_ids_on_newly_loaded_layout,
        set_dataset_parameters,
    } from "./svelte_stores/catalog_and_info_store.js";

    import { layout } from "./svelte_stores/layout_store";

    import {
        AccordionItem,
        Accordion,
        Button,
        ButtonGroup,
        Dropdown,
        DropdownItem,
        DropdownHeader,
        Label,
        Helper,
        Modal,
        Fileupload,
    } from "flowbite-svelte";

    import { ChevronRight } from "svelte-heros-v2";

    import { uid } from "./svelte_stores/uid_store.js";

    import SubplotEdit from "./subplot_forms/SubplotEdit.svelte";
    import LayoutGlobalForm from "./LayoutGlobalForm.svelte";
    let showLayout = false;
    let showUpload = false;

    let new_subplot_dropdown_open = false;

    const add_subplot = function (subplot_template) {
        $uid = $uid + 1;
        $layout.subplots = [
            ...$layout.subplots,
            {
                ...JSON.parse(JSON.stringify(subplot_template)),
                computed: { id: $uid },
            },
        ];
        set_dataset_parameters(set_ids_on_newly_loaded_layout($layout));
    };

    // Read a new file with layout
    const loadLayout = function (e) {
        var file = e.target.files[0];
        if (!file) {
            return;
        }
        var reader = new FileReader();
        reader.onload = function (e) {
            let contents = e.target.result;
            let new_layout = JSON.parse(contents);
            // query_client.clearQueries(['catalog']);
            // query_client.clearQueries(['info']);
            // query_client.clearQueries(['data']);
            $layout = set_dataset_parameters(
                set_ids_on_newly_loaded_layout(new_layout),
            );
        };
        reader.readAsText(file);
    };

    // Remove computed fields for layout download:
    const remove_computed = function (obj) {
        let obj_copy = JSON.parse(JSON.stringify(obj));
        for (const subplot of obj_copy.subplots) {
            delete subplot.computed;
            for (const plot_element of subplot.plot_elements) {
                delete plot_element.computed;
            }
        }
        return JSON.stringify(obj_copy, null, 2);
    };

    const download_json = function (download_content, filename) {
        var blob = new Blob([download_content]);
        let link = document.createElement("a");
        if (link.download !== undefined) {
            // Browsers that support HTML5 download attribute
            var url = URL.createObjectURL(blob);
            link.setAttribute("href", url);
            link.setAttribute("download", filename);
            link.style.visibility = "hidden";
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
    };
</script>

<div class="p-0">
    <Accordion>
        <AccordionItem>
            <span slot="header"> Global settings </span>
            <LayoutGlobalForm />
        </AccordionItem>
        {#each $layout.subplots as subplot, i_subplot (subplot.computed.id)}
            <AccordionItem>
                <span slot="header">
                    {i_subplot + 1}. {subplot.title}
                </span>
                <SubplotEdit {i_subplot} />
            </AccordionItem>
        {/each}
    </Accordion>

    <div class="flex flex-row justify-between mt-3">
        <Button size="sm" outline color="blue">
            New subplot<ChevronRight />
        </Button>
        <Dropdown
            class="overflow-y-auto"
            placement="right-start"
            bind:open={new_subplot_dropdown_open}>
            <DropdownHeader>Presets:</DropdownHeader>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_empty);
                    new_subplot_dropdown_open = false;
                }}>Empty subplot</DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_sunspots);
                    new_subplot_dropdown_open = false;
                }}>Sunspot number</DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_f10_7);
                    new_subplot_dropdown_open = false;
                }}>Solar radio flux at 10.7 cm</DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_xray_flux);
                    new_subplot_dropdown_open = false;
                }}>X-ray flux<Helper>Log10 scale</Helper></DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_hp30_index);
                    new_subplot_dropdown_open = false;
                }}
                >Hp30 index<Helper>Colour-coded bar plot</Helper></DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_imf);
                    new_subplot_dropdown_open = false;
                }}
                >Interplanetary Magnetic Field<Helper
                    >Combination of multiple area/line styles</Helper
                ></DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_swarm_ne);
                    new_subplot_dropdown_open = false;
                }}
                >Swarm electron density<Helper>Satellite constellation</Helper
                ></DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_ae_magnetometers);
                    new_subplot_dropdown_open = false;
                }}
                >Intermagnet magnetomter data and OMNIWEB AE index<Helper
                    >Geomagnetic conditions</Helper
                ></DropdownItem>
            <DropdownItem
                on:click={() => {
                    add_subplot(subplot_template_gold);
                    new_subplot_dropdown_open = false;
                }}
                >GOLD 135.6 nm<Helper>NASA GOLD 135.6 nm images</Helper
                ></DropdownItem>

            <!-- <DropdownDivider/>
            <DropdownItem>Swarm Ne vs latitude<Helper>Time interval image / colourbar</Helper></DropdownItem>
            <DropdownItem>GOES SUVI<Helper>Timestamped image</Helper></DropdownItem> -->
        </Dropdown>
        <ButtonGroup size="sm">
            <Button
                color="blue"
                outline
                on:click={() => (showLayout = !showLayout)}>Show layout</Button>
            <Button
                color="blue"
                outline
                on:click={() => (showUpload = !showUpload)}
                >Upload layout</Button>
        </ButtonGroup>
    </div>
</div>

<Modal bind:open={showLayout} autoclose={true} outsideclose={true}>
    <div slot="header">
        <h1 class="text-3xl font-bold">Layout</h1>
    </div>
    <pre class="text-xs">{remove_computed($layout)}</pre>
    <div slot="footer">
        <Button
            size="sm"
            on:click={() => {
                download_json(
                    remove_computed($layout),
                    "timeline_viewer_layout.json",
                );
            }}>Download layout</Button>
    </div>
</Modal>

<Modal bind:open={showUpload} autoclose={true} outsideclose={true}>
    <div slot="header"><h1 class="text-3xl font-bold">Upload layout</h1></div>
    <Label
        >Upload your previously saved json layout file here:
        <Fileupload
            on:change={(e) => {
                loadLayout(e);
                showUpload = false;
            }} />
    </Label>
</Modal>

<style>
</style>
